******************************************************************
*  Part of CPYTH package, interface between COMPHEP and PYTHIA   *
*		    Monte-Carlo generators			 *
******************************************************************
*  authors:  S.Balatenyshev,A.Sherstnev 			 *
*  version:  2.0.01						 *
*  date:    28.07.2002  					 *
******************************************************************    
	
      SUBROUTINE READER

#include "include/structures.inc"		

	CHARACTER*1000 string,xstring
	INTEGER length,xlength,num,OK
	INTEGER STRLEN             ! FUNCTION

	xstring=""	! exchange string for cap reading
	xlength=0	! length of exchange string
	num=0
	OK=0
	
10	read(IS,'(a)') string 

	if(string(1:2).ne."##".and.OK.eq.0) then
	  write(*,*)'Error: The file ',filename,' is not in CPYTH format'
	  write(*,*)'string:  ',string
	  stop
	else
	  OK=1
	endif
	
**********************************************
*.....Reading the tag and fill tagbase	

	  length=STRLEN(string)
	  if(string(length:length).eq.';') then
	    num=num+1
	    length=length+xlength
	    string=xstring(:xlength)//string
	    if(string(length-1:length).eq.';;') then
	      string=string(:length-1)
	      tagnum=num
	      call tagbase_init(num,string,length-1)
	      xstring=""
	      xlength=0	
	    else
	      call tagbase_init(num,string,length)
	      xstring=""
	      xlength=0
	      goto 10
	    endif
	  else
	    xstring=xstring(:xlength)//string(:length)
	    xlength=xlength+length
	    goto 10
	  endif
      end

      INTEGER FUNCTION EVREADER(DUB)
#include "include/structures.inc"		

	INTEGER ATOI,STRLEN           ! FUNCTION
	INTEGER i,j,past,DUB
	CHARACTER  string*500

	READ(IS,'(a)') string 
	length=strlen(string)
	j=1
	past=1
	DO i=1,length
	  IF (string(i:i).eq.':') THEN
	     ev(j)=string(past:i-1)
	     j=j+1
	     past=i+1
	  ENDIF  
	ENDDO
	EV(0)='0'
	EVREADER=ATOI(ev(1),3)
	RETURN
      END
      

      SUBROUTINE tagbase_init(num,string,length)	
#include "include/structures.inc"		

	CHARACTER*1000 string
	INTEGER length,num,vlen

	INTEGER i,char_flag
	INTEGER STRLEN             ! FUNCTION
	
**********************************************
*.....Removing spaces and tabs in the string		
	string=string(3:)
	length=length-2
	i=1
	char_flag=0	              ! flag of CHARACTER command in the string

	if(string.eq.':,;') return    ! excluding empty strings
		
	do 11 while (string(i:i).ne.';')
	
	  if(string(i:i).eq."'") then
	    if(char_flag.eq.0) then
	     char_flag=1
	    else
	     char_flag=0
	    endif
	  endif

	  if((string(i:i).le.' ').and.(char_flag.ne.1)) then
	    string=string(:i-1)//string(i+1:)
	    length=length-1
	  else
	    i=i+1
	  endif
11	continue

************************************************
*.....Determining tag names, commands and values

	point=1		! delimiter position
	comnum(num)=0   ! amount of commands in the string
	do i=1, length
	  if(string(i:i).eq.':') then
	    if(i.gt.50) then
	      write(*,*)'Error: Tagname exceed 50 symbols, ',string(point:i-1)
	      stop
	    endif
	    tagname(num)=string(point:i-1)
	    point=i
	    goto 20
	  endif
	enddo

  20	do i=point,length
	  if(string(i:i).eq.'=') then
	    if((i-point+1).gt.100) then
	      write(*,*)'Error: Command name exceed 100 symbols, ',string(point+1:i-1)
	      stop
	    endif
	    comnum(num)=comnum(num)+1
	    command(num,comnum(num))=string(point+1:i-1)
	    point=i
	  endif

	  if(string(i:i).eq.',') then
	    if((i-point+1).gt.100) then
	      write(*,*)'Error: Command value exceed 100 symbols,',string(point+1:i-1)
	      stop
	    endif
	    value(num,comnum(num))=string(point+1:i-1)
	    if(value(num,comnum(num))(1:1).eq."'") then
	      vlen=STRLEN(value(num,comnum(num)))
	      value(num,comnum(num))=value(num,comnum(num))(2:vlen-1)
	    endif
	    point=i
	  endif
	enddo
      end
