******************************************************************
*  Part of CPYTH package, interface between COMPHEP and PYTHIA   *
*		    Monte-Carlo generators			 *
******************************************************************
*  authors:  A.Sherstnev                                         *
*  version:  2.0.01						 *
*  date:    28.07.2002  					 *
******************************************************************    
	
      SUBROUTINE LHP_writer
#include "include/structures.inc"	
#include "include/leshouches.inc"
	INTEGER I

	WRITE(IST,*)'BEAM 1: ID=',IDBMUP(1),', ENERGY=',EBMUP(1)
	WRITE(IST,*)'BEAM 2: ID=',IDBMUP(2),', ENERGY=',EBMUP(2)
	WRITE(IST,*)'STRFUN 1: GR=',PDFGUP(1),', ID=',PDFSUP(1)
	WRITE(IST,*)'STRFUN 2: GR=',PDFGUP(2),', ID=',PDFSUP(2)
	WRITE(IST,*)'NUMBER OF PROCESSES: ',NPRUP
	DO I=1,NPRUP
	  WRITE(IST,*)'PROCESS: ',I
	  WRITE(IST,*)'CROSS SECTION: ',XSECUP(I)
	  WRITE(IST,*)'ERROR: ',XERRUP(I)
	  WRITE(IST,*)'MAX WIEGHT: ',XMAXUP(I)
	  WRITE(IST,*)'LISTING: ',LPRUP(I)
	  WRITE(IST,*)' '
	  ENDDO
	WRITE(IST,*)'MASTER SWICH: ',IDWTUP
      END

      SUBROUTINE LHE_writer
#include "include/structures.inc"	
#include "include/leshouches.inc"
	INTEGER I
	
	WRITE(IST,*)'****************************************************'
	WRITE(IST,*)'EVENT:'
	WRITE(IST,*)'NUMBER OF PARTICLES: ',NUP
	WRITE(IST,*)'PROCESS      NUMBER: ',IDPRUP
	WRITE(IST,*)'EVENT WIEGHT: ',XWGTUP
	WRITE(IST,*)'EVENT SCALE: ',SCALUP
	WRITE(IST,*)'QED ALPHA: ',AQEDUP
	WRITE(IST,*)'QCD ALPHA: ',AQCDUP
	DO I=1,NUP
	  WRITE(IST,*)'PARTICLE: ',I
	  WRITE(IST,*)'KF CODE: ',IDUP(I)
	  WRITE(IST,*)'STATUS CODE: ',ISTUP(I)
	  WRITE(IST,*)'MOMENTUM: PX=',PUP(1,I),', PY=',PUP(2,I),', PZ=',PUP(3,I)
	  WRITE(IST,*)'ENERGY: PX=',PUP(4,I),', MASS=',PUP(5,I)
	  WRITE(IST,*)'MOTHER NUMBERS: N1=',MOTHUP(1,I),', N2=',MOTHUP(2,I)
	  WRITE(IST,*)'COLOR FLOW',ICOLUP(1,I),'--',ICOLUP(2,I)
	  WRITE(IST,*)'TIME: ',VTIMUP(I)
	  WRITE(IST,*)'SPIN: ',SPINUP(I)
	  WRITE(IST,*)' '
	  ENDDO
      END


      SUBROUTINE tagbase_writer(wfile)	
#include "include/structures.inc"		
	character*60 wfile
	INTEGER I,J

	DO I=1,tagnum
	  WRITE(*,*)'TAG NAME: ',tagname(I)
	  DO J=1,comnum(I)
	    WRITE(*,*)'  COMMAND: NAME=',command(I,J),', VALUE',value(I,J)
	  ENDDO
	ENDDO
      END







