******************************************************************
*  Part of CPYTH package, interface between COMPHEP and PYTHIA   *
*		    Monte-Carlo generators			 *
******************************************************************
*  authors:  S.Balatenyshev,A.Sherstnev 			 *
*  version:  2.0.01						 *
*  date:    28.07.2002  					 *
******************************************************************

      SUBROUTINE fill_process
#include "include/structures.inc"	
#include "include/leshouches.inc"
	INTEGER GT_1exactcom,GT_1com   ! FUNCTIONS
	INTEGER LENINT,ATOI            ! FUNCTION
	REAL*8 ATOF                    ! FUNCTION
	INTEGER PDFinfo                ! FUNCTION
	INTEGER NID,I,N
	CHARACTER*10 ID
	CHARACTER*100 TEMP,PDFname,PDFversion

	DO I=1,2
	  CALL ITOA(ID,I)
	  n = GT_1exactcom(0,'beam',4,'ID',2,ID,1)
	  n = GT_1com(n,'beam',4,'energy',6,temp)
	  IF(n.ne.-1) EBMUP(i)=ATOF(temp)
	  n = GT_1com(n,'beam',4,'KF',2,temp)
	  IF(n.ne.-1) IDBMUP(i)=ATOI(temp,10)

	  n = GT_1exactcom(0,'strfun',6,'IDbeam',6,id,1)
	  n = GT_1com(n,'strfun',6,'name',4,temp)
	  IF(n.ne.-1) PDFname=temp
	  n = GT_1com(n,'strfun',6,'version',7,temp)
	  IF(n.ne.-1) THEN
	    PDFversion=temp
	  ELSE 
	    PDFversion=' '
	  ENDIF
	  PDFGUP(i)=PDFinfo('grup',PDFname,PDFversion)
	  PDFSUP(i)=PDFinfo('name',PDFname,PDFversion)	
	ENDDO

	n = GT_1com(n,'process',7,'master',6,temp)
	IF(n.ne.-1) IDWTUP=ATOI(temp,2)
	n = GT_1com(n,'total',5,'Nproc',5,temp)
	IF(n.ne.-1) NPRUP=ATOI(temp,3)
	
	DO i=1,NPRUP
	  CALL itoa(id,i)
	  NID=LENINT(i)
	  n = GT_1exactcom(0,'process',7,'ID',2,ID,NID)
	  n = GT_1com(n,'process',7,'CrosSec',7,temp)
	  IF(n.ne.-1) XSECUP(i)=ATOF(temp)
	  n = GT_1com(n,'process',7,'CrosSecErr',10,temp)
	  IF(n.ne.-1) XERRUP(i)=ATOF(temp)
	  LPRUP(i)=i
	  XMAXUP(i)=1.0
	ENDDO
      END

      SUBROUTINE GEN_EVENT_INFO
#include "include/structures.inc"	
	INTEGER GT_1com,GT_1exactcom,GET_IVAL ! FUNCTIONS
	INTEGER ATOI,LENINT                   ! FUNCTIONS
	INTEGER N,NPROC,NID,NT
	INTEGER I,J,K
	REAL*8  GET_FVAL         ! FUNCTION
	CHARACTER TEMP*100,ID*100
	
	N = GT_1com(0,'total',5,'Nproc',5,TEMP)
	NPROC=ATOI(TEMP,3)
	DO I=1,NPROC
	  CALL ITOA(ID,I)
	  NID=LENINT(I)
	  N = GT_1exactcom(0,'process',7,'ID',2,ID,NID)
	  NPART(I)=GET_IVAL('Nparton',7,N)
	  N = GT_1exactcom(0,'QCDinfo',7,'ID',2,ID,NID)
	  QCDL(I) = GET_FVAL('QCDLambda',9,N)
	  NL(I)   = GET_IVAL('NL',2,N)
	  N=0
	  DO K=1,NPART(I)
	    N = GT_1exactcom(N+1,'parton',6,'IDprocess',9,ID,NID)
	    MASS(I,K) = GET_FVAL('mass',4,N)
	    KF(I,K)   = GET_IVAL('KF',2,N)
	  ENDDO
	 
	  N = GT_1exactcom(0,'format',6,'IDprocess',9,ID,NID)
	  IF(N.EQ.-1) THEN
	    write(*,*)'Errors in format tag with IDprocess=',i
	    STOP
	  ENDIF	  
	  DO J=2,COMNUM(N)
	    DO K=1,NPART(I)
	      CALL ITOA(ID,K)
	      NID=LENINT(K)
	      NT=NID+3
	      TEMP='p'//ID(1:NID)//'.1'
	      IF(COMMAND(N,J)(1:NT).EQ.TEMP(1:NT)) IP(I,K,1)=J-1
	      TEMP='p'//ID(1:NID)//'.2'
	      IF(COMMAND(N,J)(1:NT).EQ.TEMP(1:NT)) IP(I,K,2)=J-1
	      TEMP='p'//ID(1:NID)//'.3'
	      IF(COMMAND(N,J)(1:NT).EQ.TEMP(1:NT)) IP(I,K,3)=J-1
	      TIME(I,K)=0
	      SPIN(I,K)=0
	    ENDDO
	    IP(I,1,1)=0
	    IP(I,1,2)=0
	    IP(I,2,1)=0
	    IP(I,2,2)=0
	    IF(COMMAND(N,J)(1:8).EQ.'Qsquared') Q(I)=J-1
	    IF(COMMAND(N,J)(1:11).EQ.'color_chain') COLORH(I)=J-1
	  ENDDO
	ENDDO
	RETURN
      END

      SUBROUTINE FILL_ENTRY
#include "include/structures.inc"	
#include "include/leshouches.inc"
	INTEGER ATOI      ! FUNCTION
	INTEGER EVREADER  ! FUNCTION
	REAL*8 ATOF       ! FUNCTION
	INTEGER NPR,I,IDUPx,IPSGN,LENGTH,N1,N2
	CHARACTER CHAIN*100,K1*1,K2*1
	REAL*8 XRND,XXX,YYY
	
       IPSGN = 1
*...if BEAM(1)=BEAM(2) the simmetrization Z->-Z is made
	IF (IDBMUP(1).eq.IDBMUP(2)) THEN
	  XRND = PYR(0)
	  IF (XRND.lt.0.5d0) IPSGN=-1
	  IF (XRND.lt.0.d0 .or. XRND.ge.1.d0) THEN
	    write (*,*) 'RAN2 out of [0,1)'
	    STOP
	  ENDIF
	ENDIF

*...the identity of the current subprocess
	IDPRUP=EVREADER(0)
	NPR=IDPRUP
*...the number of particle entries in the current event
	NUP=NPART(NPR)
	
*...the event weight
        XWGTUP = 1.d0
*...scale Q of the event (factorization scale)
	SCALUP=ATOF(ev(Q(NPR)))
*...the QED coupling used
      AQEDUP = -1    ! not QED process
*...the QCD coupling used for this event (ME)
c	write(*,*)'point 4.1!, SCALE=',SCALUP,', QCDL=',QCDL(NPR),
c     &            ', NL=',NL(NPR)
	AQCDUP=ALPHAS2(SCALUP,QCDL(NPR),NL(NPR))
	
	DO i=1,NUP
	  PUP(1,i)=ATOF(ev(IP(NPR,I,1)))
	  PUP(2,i)=ATOF(ev(IP(NPR,I,2)))
	  PUP(3,i)=ATOF(ev(IP(NPR,I,3)))*IPSGN
	  PUP(5,i)=MASS(NPR,I)	    
	  PUP(4,i)=SQRT(PUP(1,i)**2+PUP(2,i)**2+PUP(3,i)**2+PUP(5,i)**2)
	  IDUP(i)=KF(npr,I)
c	  write(*,*)'PUP(1,i)=',PUP(1,i),', PUP(2,i)=',PUP(2,i),
c     .    ', PUP(3,i)=',PUP(3,i)
*...invariant lifetime
	  VTIMUP(i)=ATOF(ev(TIME(NPR,I)))
*...spin information
	  SPINUP(i)=ATOF(ev(SPIN(NPR,I)))

	  IF(i.lt.3) THEN
*...status code of 1 and 2 particles
	    ISTUP(i)=-1
*...position of first and last mother of 1 and 2 particles
	    MOTHUP(1,i)=0
	    MOTHUP(2,i)=0
	  ELSE
*...status code of other particles
	    ISTUP(i)=1
*...position of first and last mother of other particles
	    MOTHUP(1,i)=1
	    MOTHUP(2,i)=2
	  ENDIF
	ENDDO

*...swap Z axis for momenta if BEAM(1)=BEAM(2)
	IF(IPSGN.EQ.-1) THEN
	  IDUPx   = IDUP(1)
	  IDUP(1) = IDUP(2)
	  IDUP(2) = IDUPx
	  DO I=1,5
	     XPUP     = PUP(I,1)
	     PUP(I,1) = PUP(I,2)
	     PUP(I,2) = XPUP
	  ENDDO
	ENDIF

*...random phi generation of event particles
      PI=DACOS(-1d0)
      XRND=2d0*PI*pyr(0)
      DO I=3,NUP
	XXX=PUP(1,I)
       YYY=PUP(2,I)
       PUP(1,I)=XXX*COS(XRND)-YYY*SIN(XRND)
       PUP(2,I)=XXX*SIN(XRND)+YYY*COS(XRND)
      ENDDO

*...Breit-Wigner smearing of masses for unstable particles in OUT state if yes
	ISMEAR=1
       IF (ISMEAR.eq.1) CALL SMEARMASS

*...set color flows
	CHAIN=EV(COLORH(NPR))
	LENGTH=0
	DO I=1,30
	  IF (CHAIN(I:I).EQ.')') LENGTH=I	  
	ENDDO
        ITAG = 500
        DO I=1,NUP
          ICOLUP(1,i) = 0
          ICOLUP(2,i) = 0
	ENDDO
	
        DO I=1,LENGTH,5
          K1=CHAIN(I+1:I+1)
          N1=ATOI(K1,1)
          K2=CHAIN(I+3:I+3)
          N2=ATOI(K2,1)
          IF(IPSGN.eq.-1) THEN
            IF(N1.eq.1) THEN
              N1=2
            ELSEIF(N1.eq.2) THEN
              N1=1
            ENDIF
            IF(N2.eq.1) THEN
              N2=2
            ELSEIF (N2.eq.2) THEN
              N2=1
            ENDIF
          ENDIF
          IF(N1.le.2) THEN
            ICOLUP(1,N1) = ITAG
          ELSE
            ICOLUP(2,N1) = ITAG
          ENDIF
          IF(N2.le.2) THEN
            ICOLUP(2,N2) = ITAG
          ELSE
            ICOLUP(1,N2) = ITAG
          ENDIF
          ITAG = ITAG+1
	ENDDO
      END
