******************************************************************
*  Part of CPYTH package, interface between COMPHEP and PYTHIA   *
*		    Monte-Carlo generators			 *
******************************************************************
*  authors:  S.Balatenyshev,A.Sherstnev 			 *
*  version:  2.0.01						 *
*  date:    28.07.2002  					 *
******************************************************************

	INTEGER MAXPUP   ! Maximum number of processes to be interfaced at one time
	INTEGER MAXNUP   ! Maximum number of particle entries
	parameter (MAXPUP=100)
	parameter (MAXNUP=500)
**************************************************************
*.....Les Houches PROCESS common block
**************************************************************

	INTEGER IDBMUP  !ID of beam particles
	INTEGER PDFGUP  !the author group for beams, according to the PDFlib specification
	INTEGER PDFSUP  !the PDF set ID for beams, according to the PDFlib specification
	INTEGER IDWTUP  !master switch dictating how the event weights (XWGTUP) are interpreted
	INTEGER NPRUP   !the number of different user subprocesses
	INTEGER LPRUP   !listing of all user process IDs that can appear
                        !in IDPRUP of HEPEUP for this run
	REAL*8 EBMUP    !energy in GeV of beam particles
	REAL*8 XSECUP   !the cross section for all processes in pb
	REAL*8 XERRUP   !the cross section statistical error of processes in pb
	REAL*8 XMAXUP   !maximum event weight for all processes

	COMMON/HEPRUP/IDBMUP(2), EBMUP(2), PDFGUP(2),PDFSUP(2),
     &	              IDWTUP, NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),
     &		      XMAXUP(MAXPUP),LPRUP(MAXPUP)
	SAVE /HEPRUP/

**************************************************************
*.....Les Houches EVENT common block
**************************************************************
	INTEGER NUP     !number of particle entries in this event
	INTEGER IDPRUP  !ID of the process for this event
	INTEGER IDUP    !particle ID according to PDG convention
	INTEGER ISTUP   !status code:
                        ! -1 Incoming particle
                        ! +1 Outgoing final state particle
	                ! -2 Intermediate space-like propagator defining an 
	                !    $x$ and $Q^2$ which should be preserved
                        ! +2 Intermediate resonance, Mass should be preserved
                        ! +3 Intermediate resonance, for documentation only
                        ! -9 Incoming beam particles at time $t=-\infty$
	INTEGER MOTHUP  !index of first and last mother
	INTEGER ICOLUP  !ICOLUP(1,I) - INTEGER tag for the color flow 
		        !line passing through the color of the particle
                        !ICOLUP(2,I) - INTEGER tag for the color flow 
		        !line passing through the anti-color of the particle*/

	REAL*8 XWGTUP   !event weight
	REAL*8 SCALUP   !scale of the event in GeV, as used for calculation of  PDFs
	REAL*8 AQEDUP   !the QED coupling used for this event
	REAL*8 AQCDUP   !the QCD coupling used for this event
        REAL*8 PUP      !lab frame momentum $(P_x, P_y, P_z, E, M)$ of particle in GeV
	REAL*8 VTIMUP   !invariant lifetime $c\tau$ (distance from 
                        !production to decay) in mm
	REAL*8 SPINUP   !cosine of the angle between the spin-vector of 
                        !particle I and the 3-momentum of the decaying 
			!particle, specified in the lab frame

	COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,
     &                IDUP(MAXNUP),ISTUP(MAXNUP),MOTHUP(2,MAXNUP),
     &                ICOLUP(2,MAXNUP),PUP(5,MAXNUP),VTIMUP(MAXNUP),
     &                SPINUP(MAXNUP)		
	SAVE/HEPEUP/
