******************************************************************
*  Part of CPYTH package, interface between COMPHEP and PYTHIA   *
*		    Monte-Carlo generators			 *
******************************************************************
*  authors:  S.Balatenyshev,A.Sherstnev 			 *
*  version:  2.0.01						 *
*  date:    17.08.2002  					 *
******************************************************************

      INTEGER FUNCTION PDFinfo(opt,name,ver)
        CHARACTER*4 opt
        CHARACTER*100 name,ver
	INTEGER PDFgr,PDFid
	
	IF(name(1:4).EQ.'MRST') THEN
	  PDFgr=3
	  IF(ver(1:3).EQ.'c-g') PDFid=72
	  IF(ver(1:2).EQ.'ht')  PDFid=77     
	elseIF(name(1:4).EQ.'CTEQ') THEN
	  PDFgr=4
	  IF(ver(1:2).EQ.'5l'.or.ver(1:2).EQ.'5L')   PDFid=46
	  IF(ver(1:2).EQ.'5m'.or.ver(1:2).EQ.'5M')   PDFid=48
	  IF(ver(1:3).EQ.'5m1'.or.ver(1:2).EQ.'5M1') PDFid=53
	  IF(ver(1:2).EQ.'4l'.or.ver(1:2).EQ.'4L')   PDFid=32
	  IF(ver(1:2).EQ.'4m'.or.ver(1:2).EQ.'4M')   PDFid=34
	elseIF(name(1:3).EQ.'GRV') THEN
	  PDFgr=5
	  IF(ver(1:4).EQ.'98HO') PDFid=13
	  IF(ver(1:4).EQ.'98LO') PDFid=12    
	elseIF(name(1:3).EQ.'ISR') THEN
	  write(*,*)'Be careful. The event were been generated with ISR!'
	  PDFgr=-1
	  PDFid=-1
	elseIF(name(1:12).EQ.'Laser photons') THEN
	  PDFgr=-1
	  PDFid=-1
	elseIF(name(1:3).EQ.'OFF') THEN
	  PDFgr=-1
	  PDFid=-1
	else
	  write(*,*)'Unknown structure FUNCTION name'
	  stop
	ENDIF
	
	IF(opt.EQ.'grup') PDFinfo=PDFgr
	IF(opt.EQ.'name') PDFinfo=PDFid
	RETURN
      END

***********************************************************
* get tag number from tags base BASE with tagname NAME    *
*  RETURN the tag number in the base			  *
* -1 IF the base DOes not contain the tag.		  *
***********************************************************
      INTEGER FUNCTION GTAG(first,tname,len)
#include "include/structures.inc"
	INTEGER i,first,len
	CHARACTER*50 tname
	
	DO i=first,tagnum	
	  IF(tagname(i)(1:len).EQ.tname(1:len)) THEN
	    GTAG=i
	    RETURN
	  ENDIF
	ENDDO
	GTAG=-1
	RETURN	
      END

***********************************************************
* get number of tag from tags base BASE with tagname NAME *
* and which contains command COM with name COM.NAME	  *
*  RETURN the tag number in the base			  *
*  COM.VALUE contains value form the tag		  *
* -1 IF the base DOes not contain the tag.		  *
***********************************************************
      INTEGER FUNCTION GT_1com(N,tname,tlen,cname,clen,cval)
#include "include/structures.inc"		
	INTEGER i,j,N,tlen,clen
	CHARACTER tname*50
	CHARACTER cname*100,cval*100 
	
	DO i=N,tagnum
	  IF(tagname(i)(1:tlen).EQ.tname(1:tlen)) THEN
	    DO j=1,comnum(i)
	      IF(command(i,j)(1:clen).EQ.cname(1:clen)) THEN
		cval=value(i,j)
	        GT_1com=i
	        RETURN
	      ENDIF
	    ENDDO
	  ENDIF
	ENDDO
	GT_1com=-1
	RETURN
      END

***********************************************************
* get number of tag from tags base BASE with tagname NAME *
* and which contains commands COM1 (with name COM1.NAME)  *
* and  COM2 (with name COM2.NAME)			  *
*  RETURN the tag number in the base			  *
*  COM1.VALUE and COM2.VALUE contain values form the tag  *
* -1 IF the base DOes not contain the tag.		  *
***********************************************************
      INTEGER FUNCTION GT_2com
     &(first,tname,cname1,cl1,cval1,cname2,cl2,cval2)
#include "include/structures.inc"		
	INTEGER i,j,first,in(2),tlen,cl1,cl2
	CHARACTER*50 tname
	CHARACTER*100 cname1,cval1,cname2,cval2
	
	DO i=first,tagnum
	  IF(tagname(i)(1:tlen).EQ.tname) THEN
	    DO j=1,comnum(i)
	      IF(command(i,j)(1:cl1).EQ.cname1(1:cl1)) THEN
	        in(1)=1
	        cval1=value(i,j)
	      ENDIF
	      IF(command(i,j)(1:cl2).EQ.cname2(1:cl2)) THEN
	        in(2)=1
	        cval2=value(i,j)
	      ENDIF
	    ENDDO
	    IF(in(1).EQ.1.and.in(2).EQ.1) THEN
	      GT_2com=i
	      RETURN
	    ENDIF
	  ENDIF
	ENDDO
	GT_2com=-1
	RETURN
      END

***********************************************************
* get number of tag from tags base BASE with tagname NAME *
* and which contains command COM			  *
*  RETURN the tag number in the base			  *
* -1 IF the base DOes not contain the tag.		  *
***********************************************************
      INTEGER FUNCTION GT_1exactcom(N,tname,tl,cname,cl,cval,vl)
#include "include/structures.inc"		
	INTEGER i,j,tl,cl,vl
	CHARACTER*50 tname
	CHARACTER*100 cname,cval
	
	DO i=N,tagnum
	  IF(tagname(i)(1:tl).EQ.tname(1:tl)) THEN
	    DO j=1,comnum(i)
	      IF(command(i,j)(1:cl).EQ.cname(1:cl).and.
     &	           value(i,j)(1:vl).EQ.cval(1:vl)) THEN
	        GT_1exactcom=i
	        RETURN
	      ENDIF
	    ENDDO
	  ENDIF
	ENDDO
	GT_1exactcom=-1
	RETURN
      END

***********************************************************
* get int value of command with name CNAME from tag T	  *
*  RETURN the the value 				  *
* -1 IF the tag DOes not contain the command.		  *
***********************************************************
      INTEGER FUNCTION get_ival(cname,cl,tnum)	
#include "include/structures.inc"		
	INTEGER i,tnum,cl
	CHARACTER*100 cname
	INTEGER ATOI             ! FUNCTION

        DO i=1,comnum(tnum)
          IF(command(tnum,i)(1:cl).EQ.cname(1:cl)) THEN
            get_ival=ATOI(value(tnum,i),20)
            RETURN
          ENDIF
	ENDDO	
	get_ival=-1
	RETURN
      END

***********************************************************
* get double value of command with name CNAME from tag T  *
* RETURN the the value, 				  *
* -1.0 IF the tag DOes not contain the command. 	  *
***********************************************************
      REAL*8 FUNCTION GET_FVAL(cname,cl,tnum)
#include "include/structures.inc"		
	INTEGER i,tnum,cl
	CHARACTER*100 cname
	REAL*8 ATOF             ! FUNCTION

        DO i=1,comnum(tnum)
          IF(command(tnum,i)(1:cl).EQ.cname(1:cl)) THEN
            GET_FVAL=ATOF(value(tnum,i))
            RETURN
          ENDIF
	ENDDO	
	GET_FVAL=-1.0
	RETURN
      END

***********************************************************
* get double value of command with name CNAME from tag T  *
* RETURN the the value, 				  *
* -1.0 IF the tag DOes not contain the command. 	  *
***********************************************************
      SUBROUTINE GET_CVAL(cname,cl,cval,tnum)
#include "include/structures.inc"		
	INTEGER i,tnum,cl
	CHARACTER*100 cname,cval

        DO i=1,comnum(tnum)
          IF(command(tnum,i)(1:cl).EQ.cname(1:cl)) THEN
            cval=value(tnum,i)
            RETURN
          ENDIF
	ENDDO	
	RETURN
      END
