******************************************************************
*  Part of CPYTH package, interface between COMPHEP and PYTHIA   *
*		    Monte-Carlo generators			 *
******************************************************************
*  author:  A.Sherstnev 					 *
*  version:  2.0.01						 *
*  date:    28.07.2002  					 *
******************************************************************
	
      SUBROUTINE validity
#include "include/structures.inc"	
#include "include/leshouches.inc"	

	INTEGER ATOI             ! FUNCTION
	INTEGER GT_1exactcom     ! FUNCTION
	INTEGER GT_1com          ! FUNCTION
	INTEGER GTAG             ! FUNCTION
	INTEGER LENINT           ! FUNCTION
	CHARACTER*100 temp
	INTEGER i,j,nn,n(5),Nparton,Nproc
	CHARACTER*10 id

**********************************************
*.....Check the beam and strfun tags

	do i=1,2
	  call itoa(id,i)
	  nn  = GT_1exactcom(1,'beam',4,'ID',2,id,1)
	  n(1) = GT_1com(nn,'beam',4,'energy',6,temp)
	  n(2) = GT_1com(nn,'beam',4,'KF',2,temp)
	  if ((nn.eq.-1).or.
     &        (nn.ne.n(1)).or.
     &        (nn.ne.n(2))) then
	    write(*,*)'Errors in beam tag with ID=',i
	    stop
	  endif
	
	  nn = GT_1exactcom(1,'strfun',6,'IDbeam',6,id,1)
	  n(1) = GT_1com(nn,'strfun',6,'name',4,temp)
	  if ((nn.eq.-1).or.(nn.ne.n(1))) then
	    write(*,*)'Errors in beam tag with ID=',i
	    stop
	  endif
	enddo
	
	nn   = GTAG(1,'total',5)
	n(1) = GT_1com(nn,'total',5,'Nproc',5,temp)
	if(n(1).ne.-1) then
	  Nproc=ATOI(temp,3)
	  if(Nproc.gt.MAXPUP) then
	    write(*,*)'Error: number of processes (',Nproc,') exceeds MAXPUP'
	    stop
	  endif
	endif
	n(2) = GT_1com(nn,'total',5,'CrosSec',7,temp)
	n(3) = GT_1com(nn,'total',5,'CrosSecErr',10,temp)
	n(4) = GT_1com(nn,'total',5,'Nevent',6,temp)
	if ((nn.eq.-1).or.
     &      (nn.ne.n(1)).or.
     &      (nn.ne.n(2)).or.
     &      (nn.ne.n(3)).or.
     &      (nn.ne.n(4))) then
	  write(*,*)'Errors in total tag.'
	  stop
	endif


	do i=1,Nproc
	  call itoa(id,i)
	  Nid=lenint(i)
	  nn   = GT_1exactcom(1,'process',7,'ID',2,id,Nid)
	  n(1) = GT_1com(nn,'process',7,'name',4,temp)
	  n(2) = GT_1com(nn,'process',7,'CrosSec',7,temp)
	  n(3) = GT_1com(nn,'process',7,'CrosSecErr',10,temp)
	  n(4) = GT_1com(nn,'process',7,'Nparton',7,temp)
	  if(n(4).ne.-1) Nparton=ATOI(temp,2)
	  n(5) = GT_1com(n,'process',7,'master',6,temp)
	  if ((nn.eq.-1).or.
     &        (nn.ne.n(1)).or.
     &        (nn.ne.n(2)).or.
     &        (nn.ne.n(3)).or.
     &        (nn.ne.n(4)).or.
     &        (nn.ne.n(5))) then
	    write(*,*)'Errors in process tag with ID=',i
	    stop
	  endif	

	  nn = GT_1exactcom(1,'generator',9,'IDprocess',9,id,Nid)
	  if (nn.eq.-1) then
	    write(*,*)'Errors in generator tag with IDprocess=',i
	    stop
	  endif	

	  nn   = GT_1exactcom(1,'n_event',7,'IDprocess',9,id,Nid)
	  n(1) = GT_1com(nn,'n_event',7,'N',1,temp)
	  if ((nn.eq.-1).or.(nn.ne.n(1))) then
	    write(*,*)'Errors in n_event tag with IDprocess=',i
	    stop
	  endif	

	  do j=1,Nparton
	    nn   = GT_1exactcom(1,'parton',6,'IDprocess',9,id,Nid)
	    n(1) = GT_1com(nn,'parton',6,'in',2,temp)
	    n(2) = GT_1com(nn,'parton',6,'out',3,temp)
	    n(3) = GT_1com(nn,'parton',6,'KF',2,temp)
	    if ((nn.eq.-1).or.
     &          (nn.ne.n(1)).or.
     &          (nn.ne.n(2)).or.
     &          (nn.ne.n(3))) then
	      write(*,*)'Errors in parton tag with IDprocess=',i
	      stop
	    endif	
	  enddo
	  
	  nn    = GT_1exactcom(1,'QCDinfo',7,'ID',2,id,Nid)
	  n(1) = GT_1com(nn,'QCDinfo',7,'NL',2,temp)
	  n(2) = GT_1com(nn,'QCDinfo',7,'Nflavour',8,temp)
	  n(3) = GT_1com(nn,'QCDinfo',7,'QCDLambda',9,temp)
	  if ((nn.eq.-1).or.
     &        (nn.ne.n(1)).or.
     &        (nn.ne.n(2)).or.
     &        (nn.ne.n(3))) then
	    write(*,*)'Errors in QCDinfo tag with ID=',i
	    stop
	  endif	

	  nn = GT_1exactcom(1,'format',6,'IDprocess',9,id,Nid)
	  if (nn.eq.-1) then
	    write(*,*)'Errors in format tag with IDprocess=',i
	    stop
	  endif	
	enddo		
      end
