/*$Log */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "LesHouches.h"
#include "tag_reader.h"
#include "tag_parser.h"
#include "event_reader.h"

#include "comphep/include/e_tools.h"
#include "comphep/include/4_vector.h"

int *Nevents;
int *Npartons;
int **pnum;
double *CSec;
double **mass;

int 
number_proc (tags * t)
{
  int res;
  string_comnd *com;

  com = malloc (sizeof (string_comnd));
  com->name = malloc (5 * sizeof (char));
  com->value = malloc (10 * sizeof (char));

  strcpy (com->name, "Nproc");
  get_tag_with1com (0, t, "total", com);
  res = atoi (com->value);
  free (com->name);
  free (com->value);
  free (com);
  return res;
}


int 
read_event (int npr, char **eventword, eventFRMT * frmt, eventUP * theEv)
{


  char buf[STRSIZE];
  char buff[STRSIZE];
  int debug = 0, err;
  int npr;
  int i, j;

  if (0 == theEv->NpartUP)
    nprt = eventword[frmt->NpartIN];
  else
    nprt = theEv->NpartUP;


  for (i = 0; i < nprt; i++)
    {
      for (j = 0; j < 3; i++)
	{
	  if (frmt->momentumIN[j][i] == 0)
	    theEv->momentumUP[j][i] = 0;
	  else
	    theEv->momentumUP[j][i] = eventword[frmt->theEv->momentumIN[j][i]];
	}

      if (theEv->momentumUP[5][i] < 0 && frmt->momentumIN[4][i] > 0)
	{
	  theEv->momentumUP[5][i] = eventword[frmt->theEv->momentumIN[5][i]];
	}
      for (k = 0, k < 3; k++)
	mom[k] = theEv->momentumUP[k][i];

      if (frmt->momentumIN[4][i] > 0)
	theEv->momentumUP[j][i] = eventword[frmt->theEv->momentumIN[4][i]];
      else
	theEv->momentumUP[4][i] = ENERGY (theEv->momentumUP[5][i], mom);
    }

  pvect[6] = 0;

  if (!fgets (buf, 1000, f))
    {
      free (eventword);
      return 0;
    }

  sscanf (buf, "%i:%[^\n]", &npr, buff);
  npr--;
  err = event_parser (buff, eventword);
  if (err)
    {
      fprintf (stderr, "Error in event %i\n. Exit!", debug);
      exit (1);
    }
  pvect[3] = atof (eventword[pnum[npr][3]]);
  pvect[7] = atof (eventword[pnum[npr][7]]);
  for (i = 2; i < Npartons[npr]; i++)
    {
      for (j = 0; j < 3; j++)
	pvect[4 * i + j + 1] = atof (eventword[pnum[npr][4 * i + j + 1]]);
    }
  for (i = 0; i < Npartons[npr]; i++)
    pvect[4 * i] = ENERGY (mass[npr][i], pvect + 4 * i + 1);
  free (eventword);

  theEv->QscaleUP = atof (eventword[Qnum[npr]]);

  for (i = 0; i < strlen (eventword[Colornum[npr]]); i++)
    {
      if (eventword[Colornum[npr]][i] == ')')
	chain++;
    }
  col = malloc (5 * chain * sizeof (int));
  new = 0;
  for (i = 0; i < chain; i++)
    {
      sscanf (eventword[Colornum[npr]] + new, "(%si %i)");

      itag = 500;
      for (i = 0; i < chain; i++)
	{
	  theEv->colorflowUP[0][col[2 * i]] = itag;
	  theEv->colorflowUP[1][col[2 * i + 1]] = itag;
	  itag++;
	}
    }
  return npr++;
}


int 
write_event (FILE * f, int npr, eventUP * theEv)
{
  int i, k, icc;
  double f;

  if (cBasisPower)
    {
      double sum = 0;
      for (i = 0; i < cBasisPower; i++)
	sum += fabs (color_weights[i]);
      sum *= drandXX ();
      for (i = 0; i < cBasisPower; i++)
	{
	  sum -= fabs (color_weights[i]);
	  if (sum <= 0)
	    break;
	}
      if (i == cBasisPower)
	i--;
      if (color_weights[i] < 0)
	n *= -1;
      icc = i;
    }

  fprintf (events_, "%2d:", 1);
  if (nin_ == 2)
    fprintf (events_, "%17.10E:%17.10E", pvect[3], pvect[7]);
  for (i = 0; i < nout_; i++)
    fprintf (events_, ":%17.10E:%17.10E:%17.10E", pvect[4 * (i + nin_) + 1], pvect[4 * (i + nin_) + 2], pvect[4 * (i + nin_) + 3]);
  fprintf (events_, ":%10.3E:", scale_ ());
  if (cBasisPower)
    {
      int j;
      for (j = 0; j < nC; j++)
	fprintf (events_, "(%d %d)", cChains[2 * nC * icc + 2 * j], cChains[2 * nC * icc + 2 * j + 1]);
    }
  fprintf (events_, ":\n");
}
